DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Custom Fill Styles

This demo uses custom patterns and gradients for PieChart slices.

Backend API
$(() => { $('#pie').dxPieChart({ dataSource: data, customizePoint(point) { const color = point.series.getPointsByArg(point.argument)[0].getColor(); let fillId; switch (point.argument) { case 'Stripes': fillId = getStrokePattern(color); break; case 'Grid': fillId = getSquarePattern(color); break; case 'Linear Gradient': fillId = getLinearGradient(color); break; case 'Radial Gradient': fillId = getRadialGradient(color); break; case 'Image': fillId = getPatternImage(color); break; default: break; } return { color: { fillId } }; }, series: [{ argumentField: 'type', valueField: 'value', label: { visible: true, connector: { visible: true }, customizeText(info) { return info.argument; }, }, }], export: { enabled: true, }, }); }); const registerGradient = DevExpress.common.charts.registerGradient; const registerPattern = DevExpress.common.charts.registerPattern; const imagePatternSize = 12; const shapePatternSize = 6; function hexToRgb(hex, opacity = 1) { const hexColorParts = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex); return `rgba(${parseInt(hexColorParts[1], 16)}, ${parseInt(hexColorParts[2], 16)}, ${parseInt(hexColorParts[3], 16)}, ${opacity})`; } function getGradient(type, color1, color2) { return registerGradient(type, { colors: [{ offset: '20%', color: color1, }, { offset: '90%', color: color2, }], }); } function getLinearGradient(color) { return getGradient('linear', color, hexToRgb(color, 0.5)); } function getRadialGradient(color) { return getGradient('radial', hexToRgb(color, 0.5), color); } function getPatternImage(color) { return registerPattern({ width: imagePatternSize, height: imagePatternSize, template: (container) => { const rect = createRect(imagePatternSize, color); const image = document.createElementNS('http://www.w3.org/2000/svg', 'image'); image.setAttribute('x', 0); image.setAttribute('y', 0); image.setAttribute('width', imagePatternSize); image.setAttribute('height', imagePatternSize); image.setAttribute('href', '../../../../images/Charts/PieWithCustomStyles/diamond.svg'); image.setAttribute('opacity', '0.6'); container.appendChild(rect); container.appendChild(image); }, }); } function getStrokePattern(color) { return registerPattern({ width: shapePatternSize, height: shapePatternSize, template: (container) => { const halfSize = shapePatternSize / 2; const oneAndAHalfSize = shapePatternSize * 1.5; const d = `M ${halfSize} ${-halfSize} L ${-halfSize} ${halfSize} M 0 ${shapePatternSize} L ${shapePatternSize} 0 M ${oneAndAHalfSize} ${halfSize} L ${halfSize} ${oneAndAHalfSize}`; const path = document.createElementNS('http://www.w3.org/2000/svg', 'path'); path.setAttribute('stroke', color); path.setAttribute('stroke-width', 2); path.setAttribute('d', d); container.appendChild(path); }, }); } function getSquarePattern(color) { return registerPattern({ width: shapePatternSize, height: shapePatternSize, template: (container) => { const rect = createRect(shapePatternSize, null, color, 2); container.appendChild(rect); }, }); } function createRect(size, fill, stroke, strokeWidth) { const rect = document.createElementNS('http://www.w3.org/2000/svg', 'rect'); rect.setAttribute('x', 0); rect.setAttribute('y', 0); rect.setAttribute('width', size); rect.setAttribute('height', size); rect.setAttribute('fill', fill); rect.setAttribute('stroke', stroke); rect.setAttribute('stroke-width', strokeWidth); return rect; }
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="pie"></div> </div> </body> </html>
#pie { height: 440px; }
const data = [{ type: 'Stripes', value: 1, }, { type: 'Grid', value: 1, }, { type: 'Linear Gradient', value: 1, }, { type: 'Radial Gradient', value: 1, }, { type: 'Image', value: 1, }];

Gradient

Call the registerGradient() method to obtain a gradient ID. Specify method arguments as follows:

  • type
    This method supports two gradient types: 'linear' and 'radial'.

  • options
    An object for gradient options.

    • colors
      An array of gradient colors. Each color is an object that includes color and offset fields. The offset field specifies the starting point for each color.

    • rotationAngle (linear gradients only)
      You can use this option to rotate linear gradients.

Pattern

To obtain a pattern ID, call the registerPattern() method. Specify method arguments as follows:

  • options
    An object with pattern options.

    • height
      Template height.

    • width
      Template width.

    • template
      A repeating SVG-based template that creates the required pattern.

Fill the PieChart

To fill all slices with the same pattern or gradient, assign a pattern ID to series.color.fillId. If you want to customize each slice individually, implement the customizePoint function (review this demo for more information).

Custom patterns and gradients are not limited to the PieChart. The following DevExtreme components support the use of patterns/gradients:

<dx-pie-chart id="pie" [dataSource]="data" [customizePoint]="customizePoint">
<dxi-pie-chart-series argumentField="type" valueField="value">
<dxo-pie-chart-label [visible]="true" [customizeText]="customizeText">
<dxo-pie-chart-connector [visible]="true"></dxo-pie-chart-connector>
</dxo-pie-chart-label>
</dxi-pie-chart-series>
<dxo-pie-chart-export [enabled]="true"></dxo-pie-chart-export>
</dx-pie-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxPieChartModule } from 'devextreme-angular';
import { registerGradient, registerPattern } from 'devextreme/common/charts';
import { Data, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxPieChartModule,
],
})
export class AppComponent {
data: Data[];
imagePatternSize = 12;
shapePatternSize = 6;
constructor(service: Service) {
this.data = service.getData();
}
customizePoint = (point) => {
const color = point.series.getPointsByArg(point.argument)[0].getColor();
let fillId;
switch (point.argument) {
case 'Stripes':
fillId = this.getStrokePattern(color);
break;
case 'Grid':
fillId = this.getSquarePattern(color);
break;
case 'Linear Gradient':
fillId = this.getLinearGradient(color);
break;
case 'Radial Gradient':
fillId = this.getRadialGradient(color);
break;
case 'Image':
fillId = this.getPatternImage(color);
break;
default:
break;
}
return { color: { fillId } };
};
customizeText = (info) => info.argument;
private hexToRgb = (hex: string, opacity = 1) => {
const hexColorParts = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
return `rgba(${parseInt(hexColorParts[1], 16)}, ${parseInt(hexColorParts[2], 16)}, ${parseInt(hexColorParts[3], 16)}, ${opacity})`;
};
private getGradient = (type: string, color1: string, color2: string) => registerGradient(type, {
colors: [{
offset: '20%',
color: color1,
}, {
offset: '90%',
color: color2,
}],
});
private getLinearGradient = (color: string) => this.getGradient('linear', color, this.hexToRgb(color, 0.5));
private getRadialGradient = (color: string) => this.getGradient('radial', this.hexToRgb(color, 0.5), color);
private getPatternImage = (color: string) => registerPattern({
width: this.imagePatternSize,
height: this.imagePatternSize,
template: (container) => {
const rect = this.createRect(this.imagePatternSize, color, '', 0);
const image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
image.setAttribute('x', '0');
image.setAttribute('y', '0');
image.setAttribute('width', this.imagePatternSize.toString());
image.setAttribute('height', this.imagePatternSize.toString());
image.setAttribute('href', '../../../../images/Charts/PieWithCustomStyles/diamond.svg');
image.setAttribute('opacity', '0.6');
container.appendChild(rect);
container.appendChild(image);
},
});
private getStrokePattern = (color: string) => registerPattern({
width: this.shapePatternSize,
height: this.shapePatternSize,
template: (container) => {
const halfSize = this.shapePatternSize / 2;
const oneAndAHalfSize = this.shapePatternSize * 1.5;
const d = `M ${halfSize} ${-halfSize} L ${-halfSize} ${halfSize} M 0 ${
this.shapePatternSize
} L ${
this.shapePatternSize
} 0 M ${oneAndAHalfSize} ${halfSize} L ${halfSize} ${oneAndAHalfSize}`;
const path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
path.setAttribute('stroke', color);
path.setAttribute('stroke-width', '2');
path.setAttribute('d', d);
container.appendChild(path);
},
});
private getSquarePattern = (color: string) => registerPattern({
width: this.shapePatternSize,
height: this.shapePatternSize,
template: (container) => {
const rect = this.createRect(this.shapePatternSize, '', color, 2);
container.appendChild(rect);
},
});
private createRect = (size: number, fill: string, stroke: string, strokeWidth: number) => {
const rect = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
rect.setAttribute('x', '0');
rect.setAttribute('y', '0');
rect.setAttribute('width', size.toString());
rect.setAttribute('height', size.toString());
rect.setAttribute('fill', fill);
rect.setAttribute('stroke', stroke);
rect.setAttribute('stroke-width', strokeWidth.toString());
return rect;
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#pie {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Data {
type: string;
value: number;
}
const data: Data[] = [{
type: 'Stripes',
value: 1,
}, {
type: 'Grid',
value: 1,
}, {
type: 'Linear Gradient',
value: 1,
}, {
type: 'Radial Gradient',
value: 1,
}, {
type: 'Image',
value: 1,
}];
@Injectable()
export class Service {
getData(): Data[] {
return data;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import PieChart, {
Series,
Label,
Connector,
Export,
} from 'devextreme-react/pie-chart';
import type { SeriesPoint } from 'devextreme/common/charts';
import {
getStrokePattern,
getSquarePattern,
getLinearGradient,
getRadialGradient,
getPatternImage,
} from './utils.ts';
import { data } from './data.ts';
function customizeText(info: { argument: string; }): string {
return info.argument;
}
type CustomizePointArg = {
series: {
getPointsByArg: (arg: string) => { getColor: () => string; }[];
};
argument: string;
};
function customizePoint(point: CustomizePointArg): SeriesPoint {
const color = point.series.getPointsByArg(point.argument)[0].getColor();
let fillId;
switch (point.argument) {
case 'Stripes':
fillId = getStrokePattern(color);
break;
case 'Grid':
fillId = getSquarePattern(color);
break;
case 'Linear Gradient':
fillId = getLinearGradient(color);
break;
case 'Radial Gradient':
fillId = getRadialGradient(color);
break;
case 'Image':
fillId = getPatternImage(color);
break;
default:
break;
}
return { color: { fillId } };
}
function App() {
return (
<PieChart
id="pie"
dataSource={data}
customizePoint={customizePoint}
>
<Series
argumentField='type'
valueField='value'>
<Label visible customizeText={customizeText}>
<Connector visible />
</Label>
</Series>
<Export enabled />
</PieChart>
);
}
export default App;
import React from 'react';
import PieChart, {
Series, Label, Connector, Export,
} from 'devextreme-react/pie-chart';
import {
getStrokePattern,
getSquarePattern,
getLinearGradient,
getRadialGradient,
getPatternImage,
} from './utils.js';
import { data } from './data.js';
function customizeText(info) {
return info.argument;
}
function customizePoint(point) {
const color = point.series.getPointsByArg(point.argument)[0].getColor();
let fillId;
switch (point.argument) {
case 'Stripes':
fillId = getStrokePattern(color);
break;
case 'Grid':
fillId = getSquarePattern(color);
break;
case 'Linear Gradient':
fillId = getLinearGradient(color);
break;
case 'Radial Gradient':
fillId = getRadialGradient(color);
break;
case 'Image':
fillId = getPatternImage(color);
break;
default:
break;
}
return { color: { fillId } };
}
function App() {
return (
<PieChart
id="pie"
dataSource={data}
customizePoint={customizePoint}
>
<Series
argumentField="type"
valueField="value"
>
<Label
visible
customizeText={customizeText}
>
<Connector visible />
</Label>
</Series>
<Export enabled />
</PieChart>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export interface Point {
type: string,
value: number,
}
export const data: Point[] = [{
type: 'Stripes',
value: 1,
}, {
type: 'Grid',
value: 1,
}, {
type: 'Linear Gradient',
value: 1,
}, {
type: 'Radial Gradient',
value: 1,
}, {
type: 'Image',
value: 1,
}];
import { registerGradient, registerPattern } from 'devextreme/common/charts';
const imagePatternSize = 12;
const shapePatternSize = 6;
function hexToRgb(hex: string, opacity = 1): string {
const hexColorParts = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
return `rgba(${parseInt(hexColorParts?.[1] ?? '', 16)}, ${parseInt(hexColorParts?.[2] ?? '', 16)}, ${parseInt(hexColorParts?.[3] ?? '', 16)}, ${opacity})`;
}
function getGradient(type: string, color1: string, color2: string): string {
return registerGradient(type, {
colors: [{
offset: '20%',
color: color1,
}, {
offset: '90%',
color: color2,
}],
});
}
export function getLinearGradient(color: string): string { return getGradient('linear', color, hexToRgb(color, 0.5)); }
export function getRadialGradient(color: string): string { return getGradient('radial', hexToRgb(color, 0.5), color); }
export function getPatternImage(color: string): string {
return registerPattern({
width: imagePatternSize,
height: imagePatternSize,
template: (container: SVGGElement): void => {
const rect = createRect(imagePatternSize, color);
const image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
image.setAttribute('x', '0');
image.setAttribute('y', '0');
image.setAttribute('width', imagePatternSize.toString());
image.setAttribute('height', imagePatternSize.toString());
image.setAttribute('href', '../../../../images/Charts/PieWithCustomStyles/diamond.svg');
image.setAttribute('opacity', '0.6');
container.appendChild(rect);
container.appendChild(image);
},
});
}
export function getStrokePattern(color: string): string {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container: SVGGElement): void => {
const halfSize = shapePatternSize / 2;
const oneAndAHalfSize = shapePatternSize * 1.5;
const d = `M ${halfSize} ${-halfSize} L ${-halfSize} ${halfSize} M 0 ${shapePatternSize} L ${shapePatternSize} 0 M ${oneAndAHalfSize} ${halfSize} L ${halfSize} ${oneAndAHalfSize}`;
const path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
path.setAttribute('stroke', color);
path.setAttribute('stroke-width', '2');
path.setAttribute('d', d);
container.appendChild(path);
},
});
}
export function getSquarePattern(color: string): string {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container: SVGGElement): void => {
const rect = createRect(shapePatternSize, null, color, 2);
container.appendChild(rect);
},
});
}
export function createRect(size: string | number, fill: string | null, stroke?: string, strokeWidth?: string | number): SVGRectElement {
const rect = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
rect.setAttribute('x', '0');
rect.setAttribute('y', '0');
rect.setAttribute('width', size.toString());
rect.setAttribute('height', size.toString());
rect.setAttribute('fill', fill ?? '');
rect.setAttribute('stroke', stroke ?? '');
rect.setAttribute('stroke-width', strokeWidth?.toString() ?? '');
return rect;
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { registerGradient, registerPattern } from 'devextreme/common/charts';
const imagePatternSize = 12;
const shapePatternSize = 6;
function hexToRgb(hex, opacity = 1) {
const hexColorParts = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
return `rgba(${parseInt(hexColorParts?.[1] ?? '', 16)}, ${parseInt(
hexColorParts?.[2] ?? '',
16,
)}, ${parseInt(hexColorParts?.[3] ?? '', 16)}, ${opacity})`;
}
function getGradient(type, color1, color2) {
return registerGradient(type, {
colors: [
{
offset: '20%',
color: color1,
},
{
offset: '90%',
color: color2,
},
],
});
}
export function getLinearGradient(color) {
return getGradient('linear', color, hexToRgb(color, 0.5));
}
export function getRadialGradient(color) {
return getGradient('radial', hexToRgb(color, 0.5), color);
}
export function getPatternImage(color) {
return registerPattern({
width: imagePatternSize,
height: imagePatternSize,
template: (container) => {
const rect = createRect(imagePatternSize, color);
const image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
image.setAttribute('x', '0');
image.setAttribute('y', '0');
image.setAttribute('width', imagePatternSize.toString());
image.setAttribute('height', imagePatternSize.toString());
image.setAttribute('href', '../../../../images/Charts/PieWithCustomStyles/diamond.svg');
image.setAttribute('opacity', '0.6');
container.appendChild(rect);
container.appendChild(image);
},
});
}
export function getStrokePattern(color) {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container) => {
const halfSize = shapePatternSize / 2;
const oneAndAHalfSize = shapePatternSize * 1.5;
const d = `M ${halfSize} ${-halfSize} L ${-halfSize} ${halfSize} M 0 ${shapePatternSize} L ${shapePatternSize} 0 M ${oneAndAHalfSize} ${halfSize} L ${halfSize} ${oneAndAHalfSize}`;
const path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
path.setAttribute('stroke', color);
path.setAttribute('stroke-width', '2');
path.setAttribute('d', d);
container.appendChild(path);
},
});
}
export function getSquarePattern(color) {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container) => {
const rect = createRect(shapePatternSize, null, color, 2);
container.appendChild(rect);
},
});
}
export function createRect(size, fill, stroke, strokeWidth) {
const rect = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
rect.setAttribute('x', '0');
rect.setAttribute('y', '0');
rect.setAttribute('width', size.toString());
rect.setAttribute('height', size.toString());
rect.setAttribute('fill', fill ?? '');
rect.setAttribute('stroke', stroke ?? '');
rect.setAttribute('stroke-width', strokeWidth?.toString() ?? '');
return rect;
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
type: 'Stripes',
value: 1,
},
{
type: 'Grid',
value: 1,
},
{
type: 'Linear Gradient',
value: 1,
},
{
type: 'Radial Gradient',
value: 1,
},
{
type: 'Image',
value: 1,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#pie {
height: 440px;
}

<template>
<DxPieChart
id="pie"
:data-source="data"
:customize-point="customizePoint"
>
<DxSeries
argument-field="type"
value-field="value"
>
<DxLabel
:visible="true"
:customize-text="customizeText"
>
<DxConnector :visible="true"/>
</DxLabel>
</DxSeries>
<DxExport :enabled="true"/>
</DxPieChart>
</template>
<script setup lang="ts">
import DxPieChart, {
DxSeries,
DxLabel,
DxConnector,
DxExport,
} from 'devextreme-vue/pie-chart';
import {
getStrokePattern,
getSquarePattern,
getLinearGradient,
getRadialGradient,
getPatternImage,
} from './utils.ts';
import { data } from './data.ts';
function customizePoint(point: any) {
const color = point.series.getPointsByArg(point.argument)[0].getColor();
let fillId;
switch (point.argument) {
case 'Stripes':
fillId = getStrokePattern(color);
break;
case 'Grid':
fillId = getSquarePattern(color);
break;
case 'Linear Gradient':
fillId = getLinearGradient(color);
break;
case 'Radial Gradient':
fillId = getRadialGradient(color);
break;
case 'Image':
fillId = getPatternImage(color);
break;
default:
break;
}
return { color: { fillId } };
}
const customizeText = ({ argument }: any) => argument;
</script>
<style>
#pie {
height: 440px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const data = [{
type: 'Stripes',
value: 1,
}, {
type: 'Grid',
value: 1,
}, {
type: 'Linear Gradient',
value: 1,
}, {
type: 'Radial Gradient',
value: 1,
}, {
type: 'Image',
value: 1,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
import * as chartMethods from 'devextreme/common/charts';
const { registerGradient, registerPattern } = chartMethods;
const imagePatternSize = 12;
const shapePatternSize = 6;
function hexToRgb(hex: string, opacity = 1): string {
const hexColorParts = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
return !hexColorParts ? 'rgba(0,0,0,0)' : `rgba(${parseInt(hexColorParts[1], 16)}, ${parseInt(hexColorParts[2], 16)}, ${parseInt(hexColorParts[3], 16)}, ${opacity})`;
}
function getGradient(type: string, color1: string, color2: string) {
return registerGradient(type, {
colors: [{
offset: '20%',
color: color1,
}, {
offset: '90%',
color: color2,
}],
});
}
export function getLinearGradient(color: string) { return getGradient('linear', color, hexToRgb(color, 0.5)); }
export function getRadialGradient(color: string) { return getGradient('radial', hexToRgb(color, 0.5), color); }
export function getPatternImage(color: string) {
return registerPattern({
width: imagePatternSize,
height: imagePatternSize,
template: (container: SVGElement) => {
const rect = createRect(imagePatternSize, color);
const image = document.createElementNS('http://www.w3.org/2000/svg', 'image');
image.setAttribute('x', '0');
image.setAttribute('y', '0');
image.setAttribute('width', imagePatternSize.toString());
image.setAttribute('height', imagePatternSize.toString());
image.setAttribute('href', '../../../../images/Charts/PieWithCustomStyles/diamond.svg');
image.setAttribute('opacity', '0.6');
container.appendChild(rect);
container.appendChild(image);
},
});
}
export function getStrokePattern(color: string) {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container: SVGElement) => {
const halfSize = shapePatternSize / 2;
const oneAndAHalfSize = shapePatternSize * 1.5;
const d = `M ${halfSize} ${-halfSize} L ${-halfSize} ${halfSize} M 0 ${shapePatternSize} L ${shapePatternSize} 0 M ${oneAndAHalfSize} ${halfSize} L ${halfSize} ${oneAndAHalfSize}`;
const path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
path.setAttribute('stroke', color);
path.setAttribute('stroke-width', '2');
path.setAttribute('d', d);
container.appendChild(path);
},
});
}
export function getSquarePattern(color: string) {
return registerPattern({
width: shapePatternSize,
height: shapePatternSize,
template: (container: SVGElement) => {
const rect = createRect(shapePatternSize, null, color, 2);
container.appendChild(rect);
},
});
}
function createRect(size: number, fill: string | null, stroke?: string, strokeWidth?: number): SVGElement {
const rect = document.createElementNS('http://www.w3.org/2000/svg', 'rect');
rect.setAttribute('x', '0');
rect.setAttribute('y', '0');
rect.setAttribute('width', size.toString());
rect.setAttribute('height', size.toString());
rect.setAttribute('fill', fill || 'none');
if (stroke) {
rect.setAttribute('stroke', stroke);
}
if (strokeWidth) {
rect.setAttribute('stroke-width', strokeWidth.toString());
}
return rect;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>